diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 1c28468c1..4334b3a74 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -1,212 +1,119 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.Font;
-import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlock;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
-
-import java.util.Random;
-
-import static org.lwjgl.opengl.GL11.*;
+import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelBlock extends ItemModelStandard {
-    private Block<?> block;
-    private BlockModel<?> blockModel;
+    private final Block<?> block;
+    private final BlockModel<?> blockModel;
     public ItemModelBlock(ItemBlock<?> itemBlock){
         super(itemBlock, null);
         this.block = itemBlock.getBlock();
         this.blockModel = BlockModelDispatcher.getInstance().getDispatch(block);
-        icon = blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, 0);
+        icon = blockModel.getOverlayTexture(0);
     }
 
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
-        return this.blockModel.getBlockTextureFromSideAndMetadata(Side.NORTH, itemStack.getMetadata());
+        return this.blockModel.getOverlayTexture(itemStack.getMetadata());
     }
 
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
-        final Minecraft mc = Minecraft.getMinecraft();
-        float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	int lightmapCoord = player.getLightmapCoord(partialTick);
-        	if(itemfullBright) {
-        		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
-        	}
-        	LightmapHelper.setLightmapCoord(lightmapCoord);	
-        }else if(mc.fullbright || itemfullBright) {
-        	
-        }else {
-        	brightness = player.getBrightness(1.0f);
-        }
-        
-        final float distanceScale = 0.8F; // Relates to how close the held item renders from the camera
-        final float swingProgress = player.getSwingProgress(partialTick);
-        final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
-        final float animationProgress = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-
-        GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
-        GL11.glTranslatef(0.7F * distanceScale, -0.65F * distanceScale - (1.0F - renderer.getEquippedProgress(partialTick)) * 0.6F, -0.9F * distanceScale); // Positions hand in correct place on right side of screen
-        GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F); // 45 degrees tilt, makes it face more towards the camera
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-
-        float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-        GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
-
-        final float scale = 0.4F;
-        GL11.glScalef(scale, scale, scale);
-
-        if (blockModel.shouldItemRender3d())
-        {
-            GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
-        }
-        renderItem(tessellator, renderer, stack, player, brightness, true);
+    public @NotNull DisplayPos getDisplayPos(@NotNull String id) {
+        return blockModel.shouldItemRender3d() ? this.blockModel.getItemDisplayPos(id) : super.getDisplayPos(id); // TODO this is jank fix with proper implementation
     }
+
     @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
-        if(BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d())
-        {
-            GL11.glEnable(GL_BLEND);
-            GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bind();
-            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
-            GL11.glDisable(GL_BLEND);
-        } else {
-            super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
+    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
+        if (!blockModel.shouldItemRender3d()) {
+            super.render(tessellator, holder, itemStack, displayPosId, items3d, clusterSize, brightness, alpha, partialTick, mirrorX);
+            return;
         }
-    }
-    @Override
-    public void heldTransformThirdPerson(ItemRenderer renderer, Entity entity, ItemStack itemStack) {
-        if(itemStack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
-            final float scale = 0.5F * 0.75F;
-            GL11.glTranslatef(0.0F, 0.1875F, -0.3125F);
-            GL11.glRotatef(20F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-            GL11.glScalef(scale, -scale, scale);
-        } else {
-            super.heldTransformThirdPerson(renderer, entity, itemStack);
+        random.setSeed(187L);
+        DisplayPos displayPos = getDisplayPos(displayPosId);
+        GL11.glTranslatef(displayPos.tx, displayPos.ty, displayPos.tz);
+        GL11.glRotatef(displayPos.rx, 1, 0, 0);
+        GL11.glRotatef(displayPos.ry, 0, 1, 0);
+        GL11.glRotatef(displayPos.rz, 0, 0, 1);
+        GL11.glScalef(displayPos.sx, displayPos.sy, displayPos.sz);
+        int color = getColor(itemStack);
+        float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
+        float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
+        float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
+        GL11.glColor4f(brightness * r, brightness * g, brightness * b, alpha);
+        for (int i = 0; i < clusterSize; i++) {
+            float rOffX = 0;
+            float rOffY = 0;
+            float rOffZ = 0;
+            if (i > 0) {
+                rOffX = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sx;
+                rOffY = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sy;
+                rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
+            }
+            GL11.glTranslatef(rOffX, rOffY, rOffZ);
+            renderSingle(tessellator, holder, itemStack, items3d, brightness, alpha, partialTick, mirrorX);
+            GL11.glTranslatef(-rOffX, -rOffY, -rOffZ);
         }
     }
+
     @Override
-    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
-        if (itemStack == null) return;
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glEnable(GL_CULL_FACE);
-        if (BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bind();
-            GL11.glPushMatrix();
-            GL11.glTranslatef(x - 2, y + 3, -3F);
-            GL11.glScalef(10F, 10F, 10F);
-            GL11.glTranslatef(1.0F, 0.5F, 1.0F);
-            GL11.glScalef(1.0F, 1.0F, -1F);
-            GL11.glRotatef(210F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-            if (useColor) {
-                final int color = getColor(itemStack);
-                final float r = (color >> 16 & 0xff) / 255F;
-                final float g = (color >> 8 & 0xff) / 255F;
-                final float b = (color & 0xff) / 255F;
-                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-            } else {
-                GL11.glColor4f(brightness, brightness, brightness, alpha);
-            }
-            GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
-            BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
-            BlockModel.renderBlocks.useInventoryTint = true;
-            GL11.glPopMatrix();
+    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
+        if (!blockModel.shouldItemRender3d()) {
+            super.renderSingle(tessellator, holder,itemStack, items3d, brightness, alpha, partialTick, mirrorX);
         } else {
-            super.renderItemIntoGui(tessellator, font, textureManager, itemStack, x, y, brightness, alpha);
+            TextureRegistry.blockAtlas.bind();
+            blockModel.renderStandalone(tessellator, itemStack.getMetadata(), brightness, alpha, null);
         }
-        GL11.glEnable(GL_CULL_FACE);
-        GL11.glDisable(GL_BLEND);
     }
-    
+
     @Override
-    public void renderAsItemEntity(Tessellator tessellator, Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
-        if (Blocks.blocksList[itemstack.itemID] != null && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d()) {
-            GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
-            TextureRegistry.blockAtlas.bind();
-            final float itemSize = blockModel.getItemRenderScale();
-            GL11.glScalef(itemSize, itemSize, itemSize);
-            for (int i = 0; i < renderCount; i++) {
-                GL11.glPushMatrix();
-                if (i > 0) {
-                    final float rOffX = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / itemSize;
-                    final float rOffY = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / itemSize;
-                    final float rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / itemSize;
-                    GL11.glTranslatef(rOffX, rOffY, rOffZ);
-                }
-                if(LightmapHelper.isLightmapEnabled()) {
-                	brightness = 1.0f;
-                	LightmapHelper.setLightmapCoord(entity.getLightmapCoord(partialTick));
-                }
-                if (Global.accessor.isFullbrightEnabled() || itemfullBright) {
-                	brightness = 1.0f;
-                }
-                blockModel.renderBlockOnInventory(tessellator, itemstack.getMetadata(), brightness, null);
-                GL11.glPopMatrix();
-            }
-        } else {
-            super.renderAsItemEntity(tessellator, entity, random, itemstack, renderCount, yaw, brightness, partialTick);
+    public void renderGui(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, float brightness, float alpha, float partialTick) {
+        if (!blockModel.shouldItemRender3d()) {
+            super.renderGui(tessellator, holder, itemStack, x, y, brightness, alpha, partialTick);
+            return;
         }
+        GL11.glPushMatrix();
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glTranslatef(x + 8, y + 8, 1);
+        GL11.glScalef(16, -16, 1);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, brightness, alpha, partialTick, false);
+        GL11.glDisable(GL11.GL_CULL_FACE);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glPopMatrix();
     }
-    
+
     @Override
-    public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
-        if (itemStack == null) return;
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glEnable(GL_CULL_FACE);
-        GL11.glEnable(GL_BLEND);
-        if (BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).shouldItemRender3d()) {
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            TextureRegistry.blockAtlas.bind();
-            if (useColor) {
-                final int color = getColor(itemStack);
-                final float r = (color >> 16 & 0xff) / 255F;
-                final float g = (color >> 8 & 0xff) / 255F;
-                final float b = (color & 0xff) / 255F;
-                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-            } else {
-                GL11.glColor4f(brightness, brightness, brightness, alpha);
-            }
-            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-            BlockModel.renderBlocks.useInventoryTint = useColor;
-            BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemStack.itemID]).renderBlockOnInventory(tessellator, itemStack.getMetadata(), brightness, alpha, null);
-            BlockModel.renderBlocks.useInventoryTint = true;
-        } else {
-            super.renderItemInWorld(tessellator, entity, itemStack, brightness, alpha, worldTransform);
+    public void renderItemEntity(@NotNull Tessellator tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, float brightness, float alpha, float partialTick) {
+        if (!blockModel.shouldItemRender3d()) {
+            super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, brightness, alpha, partialTick);
+            return;
         }
-        GL11.glDisable(GL_CULL_FACE);
-        GL11.glDisable(GL_BLEND);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glRotated(yaw, 0, 1, 0);
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, brightness, alpha, partialTick, false);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
+
     @Override
     public int getColor(ItemStack stack)
     {
-        return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(stack.getMetadata());
+        return BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(stack.getMetadata(), 0);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index 792841bc9..bb6df22ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -1,11 +1,6 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerRemote;
-import net.minecraft.client.render.Font;
-import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.TextureManager;
-import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.monster.MobSkeleton;
@@ -13,67 +8,37 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_CULL_FACE;
-import static org.lwjgl.opengl.GL11.GL_LIGHTING;
-import static org.lwjgl.opengl.GL11.glBlendFunc;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-
 public class ItemModelBow extends ItemModelStandard {
     public ItemModelBow(Item item, String namespace) {
         super(item, namespace);
     }
 
     @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, Entity entity, float brightness, boolean handheldTransform) {
-        super.renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
+    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
+        super.renderSingle(tessellator, holder, itemStack, items3d, brightness, alpha, partialTick, mirrorX);
         Item nextArrow = null;
-        if (entity instanceof Player){
-            Player entityplayer = (Player)entity;
+        if (holder instanceof Player){
+            Player entityplayer = (Player)holder;
             nextArrow = getNextArrow(entityplayer);
-        }
-        if (entity instanceof MobSkeleton){
-            if (((MobSkeleton) entity).attackTime < 5){
+        } else if (holder instanceof MobSkeleton){
+            if (((MobSkeleton) holder).attackTime < 5){
                 nextArrow = Items.AMMO_ARROW;
             }
         }
         if (nextArrow != null){
-            GL11.glRotatef(-90, 0, 0, 1);
-            GL11.glTranslatef(-1,0, 0.0625f);
-            ItemModelDispatcher.getInstance().getDispatch(nextArrow).renderItem(tessellator, renderer, itemstack, entity, brightness, false);
+            GL11.glPushMatrix();
+            GL11.glRotatef(90, 0, 0, 1);
+            GL11.glTranslatef(0.0001f, 0.0001f, 0);
+            GL11.glScalef(1, 1, 0.999f);
+            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), items3d, mirrorX);
+            GL11.glPopMatrix();
         }
     }
-    @Override
-    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
-        Minecraft mc = Minecraft.getMinecraft();
-        Item nextArrow = getNextArrow(mc.thePlayer);
-        if (itemStack == mc.thePlayer.getHeldItem() && nextArrow != null){
-            glEnable(GL_BLEND);
-            glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            glEnable(GL_CULL_FACE);
-            ItemModelStandard arrowModel = (ItemModelStandard) ItemModelDispatcher.getInstance().getDispatch(nextArrow);
-            IconCoordinate textureIndex = arrowModel.getIcon(mc.thePlayer, nextArrow.getDefaultStack());
-            GL11.glDisable(GL_LIGHTING);
-            textureIndex.parentAtlas.bind();
-            if (useColor) {
-                final int color = getColor(itemStack);
-                final float r = (color >> 16 & 0xff) / 255F;
-                final float g = (color >> 8 & 0xff) / 255F;
-                final float b = (color & 0xff) / 255F;
-                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-            } else {
-                GL11.glColor4f(brightness, brightness, brightness, alpha);
-            }
-            renderTexturedQuad(tessellator, x, y, textureIndex, true, false);
-            glEnable(GL_LIGHTING);
-            glEnable(GL_CULL_FACE);
-            glDisable(GL11.GL_BLEND);
-        }
-        super.renderItemIntoGui(tessellator, font, textureManager, itemStack, x, y, brightness, alpha);
-    }
+
     public Item getNextArrow(Player player){
         if (player instanceof PlayerRemote){
             int id = player.getArrowId();
@@ -82,13 +47,4 @@ public class ItemModelBow extends ItemModelStandard {
         }
         return player.getNextArrow();
     }
-    @Override
-    public void heldTransformThirdPerson(ItemRenderer renderer, Entity entity, ItemStack itemStack) {
-        GL11.glTranslatef(0.0F, 0.125F, 0.3125F);
-        GL11.glRotatef(-20.0F, 0.0F, 1.0F, 0.0F);
-        final float scale = 0.625F;
-        GL11.glScalef(scale, -scale, scale);
-        GL11.glRotatef(-100.0F, 1.0F, 0.0F, 0.0F);
-        GL11.glRotatef(45.0F, 0.0F, 1.0F, 0.0F);
-    }
 }
